' **** NAME: Start_iTunes.vbs                                                         
' **** AUTHOR: Oliver Lewald
' **** EMAIL: olewald@t-online.de
' **** Creation DATE 02/12/2007    
' **** Modify Date 02/26/2008
' **** VERSION : 1.3
'*********************************************************************
' **** Folgende Aufgaben fhrt das Script aus:
'---------------------------------------------------------------------
' **** Prfen ob der WHS Online ist, wenn nicht Hinweis.
' **** wenn Online dem WHS bzw. dem Shared Folder einen Laufwerksbuchstaben zuweisen
' **** HINWEIS: Dieser Buchstabe sollte dann auch in Eigenschaften von iTunes als Pfad zur Musik stehen
' **** Prfen ob bereits ein Instanz von iTunes luft, wenn ja Abbruch
' **** Backup fr ITL Datei in vorgegebenes Verzeichnis durchfhren
'---------------------------------------------------------------------
' BONUS
'---------------------------------------------------------------------
' Nach dem ffnen von iTunes
' - den ersten Song einer vorgegebenen Playliste abspielen oder
' - einen ganz bestimmten Song abspielen
'*********************************************************************
'* geplante Features
'*****************************
' Erstellen einer Datei aller seit einem bestimmten Datum zum
' Shared Folder hinzugefgten Songs, damit jeder User die Titel zu seiner 
' individuellen Mediathek ggf. hinzufgen kann
'*****************************



set netzobjekt=wscript.createobject("wscript.network")
set datenobj=CreateObject("Scripting.FileSystemObject")





'=============================
' Konfigurierbare Objekte
'=============================

' Dateien die als Backup kopiert werden sollen
strXMLName = "iTunes Library.xml"
strName = "iTunes Library.itl"

'************************************************
'Pfad zu den Dateien
strFolderPath = "H:\Musik\ITL\Aktuelle ITL\"

'***************************************************************************************
'Pfad zur Sicherung der Dateien (kann auch zentraler Pfad fr alle User zum WHS sein)
strSavePath = "H:\\Musik\ITL\Aktuelle ITL\Previous iTunes Libraries\"

'***************************************************************************************
' Laufwerksbuchstabe fr Shared Musik Folder (WHS)
strDrive = "Z:"

'*********************************************************************************
' Pfad zum Shared Musik Folder (WHS)
strPath = "\\FILE-SERVER\MUSIK"




'=======================
' Start des Scriptes
'=======================

' Prfen ob Shared Folder (\\Server\Folder) bereits verbunden ist	
    If datenobj.FolderExists(strPath) Then

	' Wenn ja, Funktion Verbinde aufrufen
	Verbinde strDrive, strPath

	Const OverwriteExisting = TRUE
	On Error resume next

	'------------------------------------------
	'* Syntax fr Backup Dateiname:
	'* Backup_Datum_Uhrzeit_User_Computer
	'------------------------------------------
	' Backup der ITL Datei durchfhren
	datenobj.CopyFile strFolderPath & strName, strSavePath & "Backup_" & myDateStr & myName & ".itl", OverwriteExisting
	datenobj.CopyFile strFolderPath & strXMLName, strSavePath & "Backup_" & myDateStr & myName & ".xml", OverwriteExisting

	' Prfen on Instanz von iTunes bereits luft (Function Verbinde)
	Check_iTunes

	' iTunes ffnen
	Set objApp = CreateObject("iTunes.Application")

    Else

	' Meldung falls der Server aus ist
        WScript.Echo "Deppflatsch!! Erst den Server einschalten, dann Musik hren!"
	WScript.Quit

    End If    

'======================
' BONUS
'======================
' Userbezogenes automatisches abpielen des ersten Songs einer Playliste 
' oder eines bestimmten Liedes
'* Durch entfernen/setzen von ' jeweils aktivieren oder deaktivieren
'*******************************************************************
Call PlayList 		' ersten Song von Playlist abspielen oder
'Call PlaySong		' vorgegebenen Song abspielen
'*******************************************************************


set datenobj = nothing
set netzobjekt = nothing
set datenobj = nothing
Set objNet = Nothing

wscript.quit

'=======================
' Ende des Scriptes
'=======================








'*********************************************************************
' Funktion zum lschen von Netzlaufwerken und neu verbinden
'*********************************************************************
Sub Verbinde(Buchstabe, Pfad)
On Error Resume Next
	' lschen von Netzwerksbuchstaben
	netzobjekt.RemoveNetworkDrive Buchstabe, true, true
On Error Goto 0
	' mappen von Server als Laufwerk
	netzobjekt.mapnetworkdrive Buchstabe, Pfad
End Sub



'***************************************************************************
' Funktion um Datum und Uhrzeit zu formatieren um an Dateinamen anzuhngen
'***************************************************************************
Function myDateStr 
     myDay = Day(Date)
     If myDay < 10 Then
          myDay = "0" & myDay
     End If
     myMonth = Month(Date)
     If myMonth < 10 Then
          myMonth = "0" & myMonth
     End If
     myYear = Year(Date)
     Std = Hour(Now)
     Min = Minute(Now)
     	If Min < 10 Then
        	Min = "0" & Min
	End If
     Zeit = Std & Min
     myDateStr = "_" & myYear & myMonth & myDay & "_" & Zeit
End Function



'******************************************************
'* Prfen ob eine Instanz von iTunes bereits luft
'* wenn ja werden alle Instanzen geschlossen.
'******************************************************
Sub Check_iTunes()
set wmi = GetObject("winmgmts:") 
set system = wmi.instancesOf("win32_process") 
for each process in system 
if lcase(process.name)="itunes.exe" then 
	process.Terminate (0)
else
end if 
	next
End Sub



'******************************************************
'* Funktion um Benutzername und Computer auszulesen
'******************************************************
Function myName
Dim objNet
On Error Resume Next
Set objNet = CreateObject("WScript.NetWork") 
If  Err.Number <> 0 Then
       'Wenn Fehler dann Meldung
	MsgBox "Nicht so schchtern." & vbCRLF &_ 
              "Nicht auf ""Nein"" klicken falls Browser dich warnt!"
	Document.Location = "UserInfo.html"	                                          
End if
myName = "_" & objNet.UserName & "_" & objNet.Computername & "_"
UserName = objNet.UserName
End Function






'************************************************************************************
' Whlt eine bestimmte Playliste aus und spielt automatisch den ersten Song davon
'************************************************************************************
Sub PlayList
Set colSources = objApp.Sources
Set objLibrary = objApp.LibraryPlaylist

' fr iTunes in DE = Mediathek, in EN = Library setzen
Set objSource = colSources.ItemByName("Mediathek")
Set colPlaylists = objSource.Playlists

' Ab hier wir die benutzerspezifische Playlist abgespielt, dazu wird der Username ausgelesen
' und die entsprechende Playliste abgespielt
Set objNet = CreateObject("WScript.NetWork") 
strName = objNet.UserName
Select Case objNet.Username   

	' Hier die div. Nutzernamen von Windows Account eintragen
	case "Liver"      
	' Hier Name der Playliste fr jeden Nutzer ndern
		Set objPlaylist = colPlaylists.ItemByName("Liver")
	case "Mela"      
		Set objPlaylist = colPlaylists.ItemByName("Mela")
		' Hier knnen noch weitere Nutzer eingetragen werden
	case Else      
End Select

' Lautstrke auf Voll setzen
objApp.SoundVolume = 100

' Ersten Song abspielen
objPlaylist.PlayFirstTrack

End Sub



'******************************************************************
' Whlt einen bestimmten Song aus und spielt ihn automatisch
'******************************************************************
Sub PlaySong
Set objLibrary = objApp.LibraryPlaylist
Set colTracks = objLibrary.Tracks

Set colPlaylists = objSource.Playlists
Set objNet = CreateObject("WScript.NetWork") 

' Ab hier wir die benutzerspezifische Datei abgespielt, dazu wird der Username ausgelesen
' und die entsprechender Song abgespielt
strName = objNet.UserName
Select Case objNet.Username   

	' Hier die div. Nutzernamen von Windows Account eintragen
	case "Liver"      
	' Hier Name der Playliste fr jeden Nutzer ndern
		Set objSong = colTracks.ItemByName("Cry Wolf")
	case "Mela"      
		Set objSong = colTracks.ItemByName("Hung up")
		' Hier knnen noch weitere Nutzer eingetragen werden
	case Else      
End Select

' Lautstrke auf Voll setzen
objApp.SoundVolume = 100

' Song abspielen
objSong.Play

End Sub
